#include "Trail.H"

uint4 Trail::length = 20;

void Trail::init(int x, int y, uint4 game_tick) {
	TrailElement pos;
	pos.x = x;
	pos.y = y;
	pos.game_tick = game_tick;
	trail.push_back(pos);
}

void Trail::update(int x, int y, uint4 game_tick) {
	if ((int)trail.size() > 0) {
		//To make sure no crashes occur
		vector<TrailElement>::iterator it = trail.end();
		if ((*it).equals(x, y)) {
			//No new position
			return;
		}
	}

	TrailElement pos;
	pos.x = x;
	pos.y = y;
	pos.game_tick = game_tick;
	trail.push_back(pos);
	if ((uint4)(trail.size()) > Trail::length) {
		vector<TrailElement>::iterator it = trail.begin();
		trail.erase(it);
	}
}

real8 Trail::getP(int x, int y, uint4 game_tick) {
	real8 p = 0;
	vector<TrailElement>::iterator it = trail.begin();
	while (it != trail.end()) {
		if ((*it).equals(x, y)) {
			real8 tmp =  it->getP(game_tick);
			if (tmp < p) {
				p = tmp;
			}
		}
		it++;
	}
	
	return p;
}

