#ifndef Trail_H
#define Trail_H

#include "GameObj.H"

using namespace std;

struct TrailElement {
	int x;
	int y;
	uint4 game_tick;

	bool equals(int mX, int mY) {
		if (mX == x && mY == y) {
			return true;
		}
		return false;
	}

	real8 getP(uint4 c_game_tick) {
		real8 mul = 0;
		real8 diff = (real8)c_game_tick - (real8)game_tick;
		if (diff <= 50) {
			mul = (real8)1;
		}
		else if (diff <= 80) {
			mul = (real8)1 - (diff - (real8)50) / (real8)30;
		}

		return -0.5 * mul;
	}
};

class Trail {
	
	public:

		void update(int x, int y, uint4 game_tick);
		void init( int x, int y, uint4 game_tick);
		real8 getP(int x, int y, uint4 game_tick);

	private:
		
		static uint4 length;
		vector<TrailElement> trail;
};

#endif
